import fs from "fs";
import path from "path";

const CURR_DIR = process.cwd();

const __dirname = path.resolve(
  path.dirname(decodeURI(new URL(import.meta.url).pathname)),
);

const createDirectoryContents = (templatePath, newProjectPath) => {
  const filesToCreate = fs.readdirSync(templatePath);

  filesToCreate.forEach((file) => {
    const origFilePath = `${templatePath}/${file}`;

    const stats = fs.statSync(origFilePath);

    if (stats.isFile()) {
      const contents = fs.readFileSync(origFilePath, "utf8");
      const writePath = `${CURR_DIR}/${newProjectPath}/${file}`;
      fs.writeFileSync(writePath, contents, "utf8");
    } else if (stats.isDirectory()) {
      fs.mkdirSync(`${CURR_DIR}/${newProjectPath}/${file}`);
      createDirectoryContents(
        `${templatePath}/${file}`,
        `${newProjectPath}/${file}`,
      );
    }
  });
};

export const handleDirectoryContent = (framework, projectName) => {
  const commonFiles = `${__dirname}/../templates/front-end/common`;
  const frameworkFiles = `${__dirname}/../templates/front-end/${framework}`;

  createDirectoryContents(commonFiles, projectName);
  createDirectoryContents(frameworkFiles, projectName);
};
